package com.izouma.awesomeadmin.web;

import java.util.*;

import com.izouma.awesomeadmin.util.ExportExcelUtil;
import org.apache.commons.lang.StringUtils;
import org.apache.shiro.authz.annotation.RequiresAuthentication;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.web.bind.annotation.*;
import com.izouma.awesomeadmin.constant.AppConstant;
import com.izouma.awesomeadmin.dto.Page;
import com.izouma.awesomeadmin.dto.Result;
import com.izouma.awesomeadmin.model.StoreLabel;
import com.izouma.awesomeadmin.service.StoreLabelService;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/**
*  controller类
*/
@Controller
@RequestMapping("/storeLabel")
@RequiresAuthentication
public class StoreLabelController {

    @Autowired
    private StoreLabelService storeLabelService;

    /**
    * <p>获取全部记录。</p>
    */
    @RequiresAuthentication
    @RequestMapping(value = "/all", method = RequestMethod.GET)
    @ResponseBody
    public Result all(StoreLabel record) {
        List<StoreLabel> pp = storeLabelService.getStoreLabelList(record);
        return new Result(true, pp);
    }

    /**
    * <p>根据Id。</p>
    */
    @RequestMapping(value = "/getStoreLabel", method = RequestMethod.GET)
    @ResponseBody
    public Result getStoreLabel(@RequestParam(required = false, value = "id") String id) {
        StoreLabel data = storeLabelService.getStoreLabelById(id);
        return new Result(true, data);
    }

    /**
    * <p>根据条件获取。</p>
    */
    @RequestMapping(value = "/getOne", method = RequestMethod.GET)
    @ResponseBody
    public Result getOne(StoreLabel record) {
        StoreLabel data = storeLabelService.getStoreLabel(record);
        return new Result(true, data);
    }


    /**
    * <p>分页查询。</p>
    */
    @RequestMapping(value = "/page", method = RequestMethod.GET)
    @ResponseBody
    public Result page(Page page, StoreLabel record) {
        Map<String, Object> result = new HashMap<>();

        List<StoreLabel> pp =storeLabelService.getStoreLabelByPage(page, record);

        result.put(AppConstant.PAGE, page);
        result.put("pp", pp);
        return new Result(true, result);
    }


    /**
    * <p>保存。</p>
    */
    @RequestMapping(value = "/save", method = RequestMethod.POST)
    @ResponseBody
    public Result save(StoreLabel record) {
        boolean num = storeLabelService.createStoreLabel(record);
        if (num) {
        return new Result(true, record.getId());
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>更新信息。</p>
    */
    @RequestMapping(value = "/update", method = RequestMethod.POST)
    @ResponseBody
    public Result updateStoreLabel(StoreLabel record) {
        boolean num = storeLabelService.updateStoreLabel(record);
        if (num) {
        return new Result(true, "保存成功");
        }
        return new Result(false, "保存异常");
    }

    /**
    * <p>删除。</p>
    */
    @RequestMapping(value = "/del", method = RequestMethod.POST)
    @ResponseBody
    public Result deleteStoreLabel(@RequestParam(required = true, value = "id") String id) {

        boolean num = storeLabelService.deleteStoreLabel(id);
        if (num) {
        return new Result(true, "删除成功");
        }
        return new Result(false, "删除异常");
    }

    /**
    * 导出Excel
    * @param request
    * @param response
    * @param record
    * @throws Exception
    */
    @RequestMapping(value = "/exportExcel", method = RequestMethod.GET)
    @ResponseBody
    public void exportExcel(HttpServletRequest request, HttpServletResponse response, StoreLabel record) throws Exception {

    List<StoreLabel> storeLabels = storeLabelService.getStoreLabelList(record);


        String sheetName = "store_label";
        String titleName = "店铺标签数据表";
        String fileName = "店铺标签表";
        int columnNumber = 8;
        int[] columnWidth = { 20,  20,  20,  20,  20,  20,  20,  20 };
        String[] columnName = {  "" ,   "删除标识" ,   "更新时间" ,   "更新人" ,   "创建时间" ,   "创建人" ,   "标签" ,   "备注"  };
        String[][] dataList = new String[storeLabels.size()][8];

        for (int i = 0; i < storeLabels.size(); i++) {

                        dataList[i][0] = String.valueOf(storeLabels.get(i).getId());
                        dataList[i][1] = String.valueOf(storeLabels.get(i).getDelFlag());
                        dataList[i][2] = String.valueOf(storeLabels.get(i).getUpdateTime());
                        dataList[i][3] = String.valueOf(storeLabels.get(i).getUpdateUser());
                        dataList[i][4] = String.valueOf(storeLabels.get(i).getCreateTime());
                        dataList[i][5] = String.valueOf(storeLabels.get(i).getCreateUser());
                        dataList[i][6] = String.valueOf(storeLabels.get(i).getLabelName());
                        dataList[i][7] = String.valueOf(storeLabels.get(i).getRemark());
                    }


        ExportExcelUtil.ExportWithResponse(sheetName, titleName, fileName,
        columnNumber, columnWidth, columnName, dataList, response);


        }
    }

